var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var Transit;
(function (Transit) {
    function loadNamespaceList(authToken) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Transit.callServer("namespaces", undefined, authToken)];
                    case 1:
                        response = _a.sent();
                        if (Transit.isSuccess(response)) {
                            resolve(response.data);
                        }
                        else {
                            reject(new Error(response.errors[0].detail));
                        }
                        return [2 /*return*/];
                }
            });
        }); });
    }
    Transit.loadNamespaceList = loadNamespaceList;
    function loadNamespace(ns) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Transit.callServer(ns + ".json")];
                    case 1:
                        response = _a.sent();
                        if (Transit.isSuccess(response)) {
                            resolve(this['$' + ns] = new Namespace(ns, response.data));
                        }
                        else {
                            reject(new Error(response.errors[0].detail));
                        }
                        return [2 /*return*/];
                }
            });
        }); });
    }
    Transit.loadNamespace = loadNamespace;
    var Namespace = /** @class */ (function () {
        function Namespace(name, hierarchy) {
            var _this = this;
            this.entities = {};
            this.loadRequests = [];
            this.vue = null;
            this.requestQueue = [];
            this.name = name;
            this.hierarchy = hierarchy;
            var apiConstructor = Transit["constructAPIFromHierarchy"];
            this.api = apiConstructor(hierarchy, name, function (dsName, entity, operation, args) {
                // TODO: supply auth
                return new Promise(function (resolve, reject) {
                    _this.callServerAuthed(dsName + "/" + entity + "/" + operation, args)
                        .then(function (response) {
                        if (isSuccess(response)) {
                            resolve(response);
                        }
                        else {
                            reject(response.errors[0].detail);
                        }
                    });
                });
            }, function (dsname, args) {
                return new Promise(function (resolve, reject) {
                    _this.callServerAuthed(dsname + "/$batch-api", args)
                        .then(function (response) {
                        if (isSuccess(response)) {
                            resolve(response);
                        }
                        else {
                            reject(response.errors[0].detail);
                        }
                    });
                });
            });
            this.oninitPromise = new Promise(function (resolve, reject) {
                _this.initResolve = resolve;
                _this.initReject = reject;
            });
        }
        Namespace.prototype.makeEntity = function (ref, options) {
            if (this.entities[ref]) {
                throw new Error("Transit: entity ${ref} already exists");
            }
            if (!options.entity) {
                options.entity = ref;
            }
            if (this.hierarchy && !this.hierarchy[options.entity]) {
                throw new Error("Transit: entity not found: " + options.entity);
            }
            else {
                return this['$' + ref] = this.entities[ref] = new Entity(ref, this, this.hierarchy[options.entity], options || {});
            }
        };
        Namespace.prototype.vueMixin = function (specs) {
            var _this = this;
            var data = {};
            var watch = {};
            var computed = {};
            for (var ref in specs) {
                var entity = this.makeEntity(ref, specs[ref]);
                data[ref] = entity.result();
                data[ref + "Status"] = entity.status;
                if (typeof entity.args == "function") {
                    computed[ref + "Args"] = entity.args;
                }
                else {
                    data[ref + "Args"] = entity.args;
                }
                watch[ref + "Args"] = {
                    handler: (function (ref) {
                        return function () { return _this.scheduleLoadRequest(ref, false); };
                    })(ref),
                    deep: true
                };
                if (!entity.options.wait && entity.spec.type != 'procedure' && entity.spec.type != 'function') {
                    this.scheduleLoadRequest(ref, false);
                }
            }
            if (!this.loadRequests.length) {
                // we have no load requests -- we're initialized
                setTimeout(function () {
                    if (_this.initResolve) {
                        _this.initResolve();
                        _this.initResolve = null;
                        _this.initReject = null;
                    }
                }, 1);
            }
            var _ns = this;
            return {
                data: data,
                computed: computed,
                watch: watch,
                created: function () {
                    _ns.vue = this;
                    for (var ref in specs) {
                        // need to do this after Vue has instrumented the result so that
                        // our custom observation methods aren't bypassed.
                        _ns.entities[ref].configureResult();
                    }
                }
            };
        };
        Namespace.prototype.findRef = function (ref) {
            if (typeof ref != "string") {
                ref = ref.$ref;
                if (!ref) {
                    throw new Error("Not a transit entity");
                }
            }
            else {
                if (!ref) {
                    throw new Error("Entity reference not found: " + ref);
                }
            }
            return ref;
        };
        Namespace.prototype.load = function (ref) {
            return this.scheduleLoadRequest(this.findRef(ref), true);
        };
        Namespace.prototype.save = function () {
            var refs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                refs[_i] = arguments[_i];
            }
            for (var i = 0; i < refs.length; i++) {
                refs[i] = this.findRef(refs[i]);
            }
            return this.processSaveRequest(refs); // don't await
        };
        Namespace.prototype.revert = function () {
            var refs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                refs[_i] = arguments[_i];
            }
            return __awaiter(this, void 0, void 0, function () {
                var _a, refs_1, ref;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = 0, refs_1 = refs;
                            _b.label = 1;
                        case 1:
                            if (!(_a < refs_1.length)) return [3 /*break*/, 4];
                            ref = refs_1[_a];
                            return [4 /*yield*/, this.entities[this.findRef(ref)].revert()];
                        case 2:
                            _b.sent();
                            _b.label = 3;
                        case 3:
                            _a++;
                            return [3 /*break*/, 1];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        Namespace.prototype.truncate = function () {
            var refs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                refs[_i] = arguments[_i];
            }
            for (var i = 0; i < refs.length; i++) {
                refs[i] = this.findRef(refs[i]);
            }
            return this.processTruncateRequest(refs); // don't await
        };
        Namespace.prototype.isUnique = function (row) {
            return this.entities[row.$ref].editedRowIdentityCount(row) <= 1;
        };
        Namespace.prototype.csv = function (ref) {
            return this.entities[this.findRef(ref)].csv();
        };
        Namespace.prototype.count = function (ref) {
            return this.entities[this.findRef(ref)].rows.length;
        };
        Namespace.prototype.scheduleLoadRequest = function (ref, returnPromise) {
            var entity = this.entities[ref];
            if (!entity) {
                throw new Error("Transit: entity not found: " + ref);
            }
            entity.loadRequested = true;
            entity.loadRequestSequence++;
            entity.status.unused = false;
            entity.status.loading = true;
            entity.status.saving = false;
            entity.status.complete = false;
            entity.status.error = "";
            var entry = { ref: ref, batchCount: 1 };
            this.loadRequests.push(entry);
            this.processLoadRequests();
            if (returnPromise) {
                return new Promise(function (resolve, reject) {
                    entry.resolve = resolve;
                    entry.reject = reject;
                });
            }
            else {
                return null;
            }
        };
        Namespace.prototype.processLoadRequests = function () {
            return __awaiter(this, void 0, void 0, function () {
                var requests, batch, _i, _a, request, entity, items, response, responseIndex, i, request, entity, returned, errmsg, i;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: 
                        // don't schedule multiple requests,
                        // and make sure to bundle all requests in an execution
                        // cycle into one batch.
                        return [4 /*yield*/, delay(1)];
                        case 1:
                            // don't schedule multiple requests,
                            // and make sure to bundle all requests in an execution
                            // cycle into one batch.
                            _b.sent();
                            if (this.loadRequests.length == 0) {
                                return [2 /*return*/];
                            }
                            requests = [];
                            batch = [];
                            for (_i = 0, _a = this.loadRequests; _i < _a.length; _i++) {
                                request = _a[_i];
                                entity = this.entities[request.ref];
                                request.version = entity.loadRequestSequence;
                                if (entity.loadRequested) {
                                    items = entity.makeLoadBatchItems(this.vue[request.ref + "Args"]);
                                    batch = batch.concat(items);
                                    // note how many results need to be consumed when processing results.
                                    // (Used for updating pageCount with paged results.)
                                    request.batchCount = items.length;
                                    requests.push(request);
                                    entity.loadRequested = false;
                                }
                            }
                            this.loadRequests = [];
                            return [4 /*yield*/, this.callServerAuthed(this.name + "/$batch-api", batch)];
                        case 2:
                            response = _b.sent();
                            responseIndex = 0;
                            for (i = 0; i < requests.length; i++) {
                                request = requests[i];
                                entity = this.entities[request.ref];
                                if (request.version != entity.loadRequestSequence) {
                                    // our entity state changed while the request was in-transit,
                                    // ignore this response
                                }
                                else {
                                    entity.status.loading = false;
                                    entity.status.complete = true;
                                    entity.updating = true;
                                    if (isSuccess(response)) {
                                        returned = entity.processLoadResponseItems(response.data.slice(responseIndex, responseIndex + request.batchCount));
                                        entity.status.error = "";
                                        if (entity.onload)
                                            entity.onload.call(this.vue, returned);
                                        if (request.resolve)
                                            request.resolve(returned);
                                    }
                                    else {
                                        if (!response.meta || typeof response.meta.batchIndex != "number" || i == response.meta.batchIndex) {
                                            errmsg = entity.status.error = response.errors[0].detail;
                                            if (entity.onloaderror)
                                                entity.onloaderror.call(this.vue, errmsg);
                                            if (request.reject)
                                                request.reject(new Error(errmsg));
                                        }
                                    }
                                }
                                responseIndex += request.batchCount;
                            }
                            for (i = 0; i < requests.length; i++) {
                                this.entities[requests[i].ref].updating = false;
                            }
                            if (this.initResolve) {
                                if (isSuccess(response)) {
                                    this.initResolve();
                                }
                                else {
                                    this.initReject(new Error(response.errors[0].detail));
                                }
                                this.initResolve = null;
                                this.initReject = null;
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        Namespace.prototype.processSaveRequest = function (refs) {
            return __awaiter(this, void 0, void 0, function () {
                var batch, rows, _i, refs_2, ref, entity, _a, _b, row, _c, _d, row, _e, refs_3, ref, entity, response, _f, rows_1, row, _g, refs_4, ref, entity;
                return __generator(this, function (_h) {
                    switch (_h.label) {
                        case 0:
                            batch = [];
                            rows = [];
                            for (_i = 0, refs_2 = refs; _i < refs_2.length; _i++) {
                                ref = refs_2[_i];
                                entity = this.entities[ref];
                                if (!entity.options.editable) {
                                    throw new Error("Cannot save entity '" + entity.ref + "' because it is not configured to be editable");
                                }
                                for (_a = 0, _b = entity.resultAsRows(); _a < _b.length; _a++) {
                                    row = _b[_a];
                                    if (row.$new) {
                                        batch.push(entity.makeInsertBatchItem(row));
                                        rows.push(row);
                                    }
                                    else if (row.$previous) {
                                        batch.push(entity.makeUpdateBatchItem(row));
                                        rows.push(row);
                                    }
                                }
                                for (_c = 0, _d = entity.removed; _c < _d.length; _c++) {
                                    row = _d[_c];
                                    batch.push(entity.makeDeleteBatchItem(row));
                                    rows.push(row);
                                }
                                entity.status.unused = false;
                                entity.status.saving = true;
                                entity.status.complete = false;
                                entity.status.error = "";
                            }
                            if (!batch.length) {
                                for (_e = 0, refs_3 = refs; _e < refs_3.length; _e++) {
                                    ref = refs_3[_e];
                                    entity = this.entities[ref];
                                    entity.status.saving = false;
                                    entity.status.edited = false;
                                    entity.status.complete = true;
                                    if (entity.onsave)
                                        entity.onsave.call(this.vue, entity.result());
                                }
                                return [2 /*return*/];
                            }
                            return [4 /*yield*/, this.callServerAuthed(this.name + "/$batch-api", batch)];
                        case 1:
                            response = _h.sent();
                            for (_f = 0, rows_1 = rows; _f < rows_1.length; _f++) {
                                row = rows_1[_f];
                                if (isSuccess(response)) {
                                    row.$previous = null;
                                    row.$new = false;
                                }
                            }
                            for (_g = 0, refs_4 = refs; _g < refs_4.length; _g++) {
                                ref = refs_4[_g];
                                entity = this.entities[ref];
                                entity.status.saving = false;
                                entity.status.complete = true;
                                if (isSuccess(response)) {
                                    entity.status.edited = false;
                                    entity.status.error = "";
                                    entity.markRevertPoint();
                                    if (entity.onsave)
                                        entity.onsave.call(this.vue, entity.result());
                                }
                                else {
                                    entity.status.error = response.errors[0].detail;
                                    if (entity.onsaveerror)
                                        entity.onsaveerror.call(this.vue, entity.status.error);
                                }
                            }
                            if (!isSuccess(response)) {
                                throw new Error(response.errors[0].detail);
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        Namespace.prototype.processTruncateRequest = function (refs) {
            return __awaiter(this, void 0, void 0, function () {
                var batch, _i, refs_5, ref, entity, response, _a, refs_6, ref, entity;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            batch = [];
                            for (_i = 0, refs_5 = refs; _i < refs_5.length; _i++) {
                                ref = refs_5[_i];
                                entity = this.entities[ref];
                                if (!entity.options.editable) {
                                    throw new Error("Cannot save entity '" + entity.ref + "' because it is not configured to be editable");
                                }
                                batch.push(entity.makeTruncateBatchItem());
                                entity.status.unused = false;
                                entity.status.saving = true;
                                entity.status.complete = false;
                                entity.status.error = "";
                            }
                            return [4 /*yield*/, this.callServerAuthed(this.name + "/$batch-api", batch)];
                        case 1:
                            response = _b.sent();
                            for (_a = 0, refs_6 = refs; _a < refs_6.length; _a++) {
                                ref = refs_6[_a];
                                entity = this.entities[ref];
                                entity.status.saving = false;
                                entity.status.complete = true;
                                entity.updating = true;
                                if (isSuccess(response)) {
                                    entity.replaceResult([]);
                                    entity.status.error = "";
                                    entity.markRevertPoint();
                                    if (entity.onsave)
                                        entity.onsave.call(this.vue, entity.result());
                                }
                                else {
                                    entity.status.error = response.errors[0].detail;
                                    if (entity.onsaveerror)
                                        entity.onsaveerror.call(this.vue, entity.status.error);
                                }
                                entity.updating = false;
                            }
                            if (!isSuccess(response)) {
                                throw new Error(response.errors[0].detail);
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        Namespace.prototype.callServerAuthed = function (path, args) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    return [2 /*return*/, new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                            var item, response, _a;
                            var _this = this;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        this.requestQueue.push({ path: path, args: args, resolve: resolve });
                                        if (this.requestQueue.length > 1) {
                                            return [2 /*return*/];
                                        }
                                        _b.label = 1;
                                    case 1:
                                        if (!(this.requestQueue.length > 0)) return [3 /*break*/, 6];
                                        item = this.requestQueue[0];
                                        return [4 /*yield*/, callServer(item.path, item.args, this.authToken)];
                                    case 2:
                                        response = _b.sent();
                                        if (!(!isSuccess(response) && response.errors[0].status == 401 && this.onautherror)) return [3 /*break*/, 5];
                                        _a = this;
                                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                                _this.onautherror(resolve);
                                            })];
                                    case 3:
                                        _a.authToken = _b.sent();
                                        return [4 /*yield*/, callServer(item.path, item.args, this.authToken)];
                                    case 4:
                                        // only 1 retry so we don't get stuck in infinite loop.
                                        response = _b.sent();
                                        _b.label = 5;
                                    case 5:
                                        item.resolve(response);
                                        this.requestQueue.shift();
                                        return [3 /*break*/, 1];
                                    case 6: return [2 /*return*/];
                                }
                            });
                        }); })];
                });
            });
        };
        return Namespace;
    }());
    var Entity = /** @class */ (function () {
        function Entity(ref, ns, spec, options) {
            this.loadRequested = false;
            this.loadRequestSequence = 0;
            this.autosaveSequence = 0;
            this.keySequence = 0;
            this.removed = [];
            this.updating = false;
            this.revertJSON = '';
            this.ref = ref;
            this.parent = ns;
            this.URLName = options.entity;
            if (options.autosave)
                options.editable = true;
            if (options.editable) {
                if (spec.type != 'table') {
                    throw new Error("Entity " + this.URLName + " cannot be editable because it is type '" + spec.type + "'");
                }
                if (!spec.identity.length) {
                    throw new Error("Entity " + this.URLName + " cannot be editable because it has no primary key");
                }
            }
            this.spec = spec;
            this.options = options;
            this.args = options.args || {};
            this.status = {
                unused: true,
                edited: false,
                loading: false,
                saving: false,
                complete: false,
                error: "",
                pageCount: 1,
            };
            this.onload = options.onload;
            this.onloaderror = options.onloaderror;
            this.onsave = options.onsave;
            this.onsaveerror = options.onsaveerror;
            var params = this.parameterSpecs();
            for (var i = 0; i < params.length; i++) {
                var pname = params[i].spec.name;
                // make our properties reactive
                if (this.args[pname] === undefined) {
                    this.args[pname] = undefined;
                }
            }
            this.updating = true;
            if (this.options.single) {
                this.singleRow = this.initRow({});
                this.singleRow.$new = true;
            }
            this.rows = this.initRows([]);
            this.updating = false;
        }
        Entity.prototype.configureResult = function () {
            this.extendRows(this.rows);
            // for a single result, we don't want to track changes to a row object.
            // this prevents our single row from being marked as non-alive.
            if (this.options.editable && !this.options.single) {
                this.observeRows(this.rows);
            }
        };
        Entity.prototype.loadOp = function () {
            return this.spec.operations.select ? "select" : "call";
        };
        Entity.prototype.parameterSpecs = function () {
            return this.spec.operations[this.loadOp()].parameters;
        };
        Entity.prototype.makeLoadBatchItems = function (args) {
            var outArgs = [];
            var params = this.parameterSpecs();
            for (var i = 0; i < params.length; i++) {
                var val = args[params[i].spec.name];
                outArgs.push(val);
            }
            var ret = [[this.URLName + "." + this.loadOp(), outArgs]];
            if (this.loadOp() == "select" && args.options && args.options.pageSize) {
                // we're paging results, we need a count to figure out pageCount
                ret.push([this.URLName + ".count", [args.filter]]);
            }
            return ret;
        };
        Entity.prototype.processLoadResponseItems = function (items) {
            var _this = this;
            if (items.length > 1) {
                // currently this only happens when we're paging results - see makeLoadBatchItems above
                // remember, our count result hasn't been objectified...
                this.status.pageCount = Math.ceil(items[1].rows[0][0] / this.args.options.pageSize);
            }
            // modify our vue data object in place so we don't break variable references to it...
            return this.replaceResult(objectifyRows(items[0], function () { return _this.initRow({}); }));
        };
        Entity.prototype.makeTruncateBatchItem = function () {
            return [this.URLName + ".truncate", []];
        };
        Entity.prototype.persistedRowIdentity = function (row) {
            var identity = [];
            for (var _i = 0, _a = this.spec.identity; _i < _a.length; _i++) {
                var ispec = _a[_i];
                if (row.$previous && typeof row.$previous[ispec.name] != 'undefined') {
                    identity.push(row.$previous[ispec.name]);
                }
                else {
                    identity.push(row[ispec.name]);
                }
            }
            return identity;
        };
        Entity.prototype.editedRowIdentity = function (row) {
            var identity = [];
            for (var _i = 0, _a = this.spec.identity; _i < _a.length; _i++) {
                var ispec = _a[_i];
                identity.push(row[ispec.name]);
            }
            return identity;
        };
        Entity.prototype.editedRowIdentityCount = function (checkRow) {
            var testStr = this.editedRowIdentity(checkRow).toString();
            var count = 0;
            for (var _i = 0, _a = this.rows; _i < _a.length; _i++) {
                var testRow = _a[_i];
                if (this.editedRowIdentity(testRow).toString() == testStr) {
                    count++;
                }
            }
            return count;
        };
        Entity.prototype.makeInsertBatchItem = function (row) {
            if (!row.$new) {
                throw new Error("Transit internal error: attempting to insert item that is already persisted");
            }
            var identity = this.editedRowIdentity(row);
            var args = {};
            for (var n in row) {
                args[n] = row[n];
            }
            for (var _i = 0, _a = this.spec.identity; _i < _a.length; _i++) {
                var ispec = _a[_i];
                delete args[ispec.name];
            }
            return [this.URLName + ".insert", identity.concat([args])];
        };
        Entity.prototype.makeUpdateBatchItem = function (row) {
            if (!row.$previous) {
                throw new Error("Transit internal error: attempting to save item that hasn't changed");
            }
            var identity = this.persistedRowIdentity(row);
            var args = {};
            // only grab the attributes that have changed,
            // but grab the new values...
            for (var n in row.$previous) {
                args[n] = row[n];
            }
            return [this.URLName + ".update", identity.concat([args])];
        };
        Entity.prototype.makeDeleteBatchItem = function (row) {
            return [this.URLName + ".delete", this.persistedRowIdentity(row)];
        };
        Entity.prototype.result = function () {
            return this.options.single ? this.singleRow : this.rows;
        };
        Entity.prototype.resultAsRows = function () {
            return this.rows;
        };
        Entity.prototype.markRevertPoint = function () {
            this.removed = [];
            this.revertJSON = JSON.stringify(this.rows);
        };
        Entity.prototype.replaceResult = function (rows) {
            this.rows["replace"](rows);
            if (rows["columns"])
                this.rows["columns"] = rows["columns"]; // check for columns existence in case of truncate
            if (this.options.single) {
                for (var n in this.singleRow) {
                    this.singleRow[n] = undefined;
                }
                if (this.rows.length) {
                    for (var n in rows[0]) {
                        this.singleRow[n] = rows[0][n];
                    }
                    this.rows[0] = this.singleRow;
                    this.singleRow.$new = false;
                }
                else {
                    this.singleRow.$new = true;
                }
                this.singleRow.$previous = null;
            }
            this.markRevertPoint();
            this.removed = [];
            this.status.edited = false;
            return this.result();
        };
        Entity.prototype.markEdited = function () {
            return __awaiter(this, void 0, void 0, function () {
                var seq;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.updating)
                                return [2 /*return*/];
                            this.status.edited = true;
                            if (this.options.single && this.rows.length == 0) {
                                this.rows.push(this.singleRow);
                            }
                            if (!this.options.autosave) return [3 /*break*/, 6];
                            seq = ++this.autosaveSequence;
                            _a.label = 1;
                        case 1: return [4 /*yield*/, delay(1)];
                        case 2:
                            _a.sent();
                            if (this.autosaveSequence != seq) {
                                // a later autosave was requested - give up.
                                return [2 /*return*/];
                            }
                            _a.label = 3;
                        case 3:
                            if (this.status.saving) return [3 /*break*/, 1];
                            _a.label = 4;
                        case 4: return [4 /*yield*/, this.parent.save(this.ref).catch(function () { })];
                        case 5:
                            _a.sent();
                            _a.label = 6;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        Entity.prototype.revert = function () {
            return __awaiter(this, void 0, void 0, function () {
                var rows;
                return __generator(this, function (_a) {
                    this.updating = true;
                    if (this.revertJSON == "") {
                        this.replaceResult([]);
                    }
                    else {
                        rows = JSON.parse(this.revertJSON);
                        this.replaceResult(rows);
                    }
                    this.updating = false;
                    this.status.edited = false;
                    return [2 /*return*/];
                });
            });
        };
        Entity.prototype.initRow = function (row) {
            // Our properties get defined *before* Vue defines its properties.
            // Don't redefine our props (say upon row re-insertion), because Vue 
            // won't redefine props either and our re-define will destroy Vue's reactivity.
            if (!row.$ref) {
                for (var _i = 0, _a = this.spec.operations[this.loadOp()].outputs; _i < _a.length; _i++) {
                    var output = _a[_i];
                    if (this.options.editable) {
                        trackChanges(row, output.spec.name, row[output.spec.name], this);
                    }
                    else {
                        Object.defineProperty(row, output.spec.name, { configurable: true, writable: true, enumerable: true, value: row[output.spec.name] });
                    }
                }
            }
            if (this.options.editable) {
                Object.defineProperty(row, "$ref", { configurable: true, writable: true, enumerable: false, value: this.ref });
                Object.defineProperty(row, "$previous", { configurable: true, writable: true, enumerable: false, value: null });
                Object.defineProperty(row, "$new", { configurable: true, writable: true, enumerable: false, value: false });
                Object.defineProperty(row, "$alive", { configurable: true, writable: true, enumerable: false, value: true });
                Object.defineProperty(row, "$key", { configurable: true, writable: true, enumerable: false, value: this.keySequence++ });
            }
            return row;
        };
        Entity.prototype.initRows = function (rows) {
            Object.defineProperty(rows, "$ref", { configurable: true, writable: true, enumerable: false, value: this.ref });
            return rows;
        };
        Entity.prototype.extendRows = function (rows) {
            // This is a workaround for JavaScript engine limitations on
            // the number of parameters to a function. For an extremely large
            // result set, the rows are splatted as arguments to splice, which
            // triggers an error in most engines. By using this method instead
            // we circumvent the need to use splice to replace an array's contents.
            Object.defineProperty(rows, "replace", {
                value: function (newRows) {
                    rows.splice(0); // this will trigger Vue reactivity if we currently have rows,
                    // for the case where newRows is empty so we still trigger
                    for (var i = 0; i < newRows.length; i++) {
                        window["Vue"].set(rows, i, newRows[i]); // this will trigger Vue reactivity
                    }
                },
                configurable: true,
                writable: true,
                enumerable: false
            });
        };
        Entity.prototype.observeRows = function (rows) {
            var _this = this;
            var markRemoved = function (row) {
                row.$alive = false;
                if (!_this.updating && !row.$new) {
                    _this.markEdited();
                    _this.removed.push(row);
                }
            };
            var orig = {
                push: rows.push,
                pop: rows.pop,
                shift: rows.shift,
                unshift: rows.unshift,
                splice: rows.splice,
                replace: rows["replace"],
            };
            var addRows = function (rowSet, start) {
                start = start || 0;
                for (var i = start; i < rowSet.length; i++) {
                    if (typeof rowSet[i] != "object" || rowSet[i] == null) {
                        throw new Error("transit row element must be an object");
                    }
                    _this.initRow(rowSet[i]);
                    if (!_this.updating) {
                        _this.markEdited();
                        rowSet[i].$new = true;
                    }
                }
                return rowSet;
            };
            rows.push = function () {
                addRows(arguments);
                return orig.push.apply(this, arguments);
            };
            rows.pop = function () {
                if (rows.length) {
                    markRemoved(rows[rows.length - 1]);
                }
                return orig.pop.apply(this, arguments);
            };
            rows.unshift = function () {
                addRows(arguments);
                return orig.unshift.apply(this, arguments);
            };
            rows.shift = function () {
                if (rows.length) {
                    markRemoved(rows[0]);
                }
                return orig.shift.apply(this, arguments);
            };
            rows.splice = function (start, length) {
                start = start || 0;
                length = length || 0;
                var removed = rows.slice(start, start + length);
                for (var i = 0; i < removed.length; i++) {
                    markRemoved(removed[i]);
                }
                addRows(arguments, 2);
                return orig.splice.apply(this, arguments);
            };
            rows["replace"] = function (newRows) {
                for (var i = 0; i < rows.length; i++) {
                    markRemoved(rows[i]);
                }
                addRows(newRows);
                return orig.replace.call(this, newRows);
            };
            return rows;
        };
        Entity.prototype.csv = function () {
            function escapeCSV(value) {
                value = (value == null || value == undefined) ? "" : String(value);
                if (value.match(/[,\n]/)) {
                    value = value.replace(/"/g, '""');
                    value = '"' + value + '"';
                }
                return value;
            }
            var outrows = [];
            var row = [];
            var cols = this.rows["columns"];
            for (var i = 0; i < cols.length; i++) {
                row.push(escapeCSV(cols[i].spec.name));
            }
            outrows.push(row.join());
            for (var i = 0; i < this.rows.length; i++) {
                row = [];
                for (var j = 0; j < cols.length; j++) {
                    row.push(escapeCSV(this.rows[i][cols[j].spec.name]));
                }
                outrows.push(row.join());
            }
            outrows.push(""); // adds trailing newline
            return outrows.join("\n");
        };
        return Entity;
    }());
    function callServer(path, args, authToken) {
        return new Promise(function (resolve, reject) {
            var oXHR = new XMLHttpRequest();
            oXHR.open("POST", "/v1/" + path, true);
            oXHR.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
            if (authToken) {
                oXHR.setRequestHeader("x-transit-authorization", authToken);
            }
            oXHR.onreadystatechange = function (oEvent) {
                if (this.readyState === 4) {
                    var json = void 0;
                    try {
                        json = JSON.parse(this.responseText);
                    }
                    catch (e) {
                        json = { errors: [{ status: -1, detail: this.responseText || "Unexpected server response" }] };
                    }
                    resolve(json);
                }
            };
            oXHR.send(JSON.stringify(args || []));
        });
    }
    Transit.callServer = callServer;
    ;
    function isSuccess(response) {
        return typeof response.data != 'undefined';
    }
    Transit.isSuccess = isSuccess;
    function delay(ms) {
        return new Promise(function (resolve) { return setTimeout(resolve, ms); });
    }
    Transit.delay = delay;
    function objectifyRows(result, rowConstructor) {
        // turn the row arrays into objects/hashes
        var outRows = [];
        for (var _i = 0, _a = result.rows; _i < _a.length; _i++) {
            var inRow = _a[_i];
            var outRow = rowConstructor();
            for (var j = 0; j < result.columns.length; j++) {
                outRow[result.columns[j].spec.name] = inRow[j];
            }
            outRows.push(outRow);
        }
        outRows["columns"] = result.columns;
        return outRows;
    }
    function trackChanges(obj, key, val, ent) {
        Object.defineProperty(obj, key, {
            configurable: true,
            enumerable: true,
            get: function () {
                return val;
            },
            set: function (newVal) {
                if (newVal === val)
                    return;
                if (this.$alive && !ent.updating) {
                    ent.markEdited();
                }
                if (!this.$previous) {
                    this.$previous = {};
                }
                this.$previous[key] = val;
                val = newVal;
            }
        });
    }
})(Transit || (Transit = {}));
/**API_CONSTRUCTOR**/
