"use strict";
/*
 * Copyright 2019 Quadrant LLC. (http://quadrant.agency/)
 *
 * This file is part of Quadrant Transit.
 *
 * Quadrant Transit is distributed without license for evaluation purposes only.
 */
Object.defineProperty(exports, "__esModule", { value: true });
class IdentityDriverBase {
    obtainCredentials(request) {
        return Promise.resolve(request.headers["x-transit-authorization"] || null);
    }
    obtainIdentity(request, response) {
        return Promise.resolve(null);
    }
    identityCredentials(credentials) {
        // in most auth modules, this will never get called
        throw new Error("not implemented");
    }
    configureFailureResponse(response) {
        response.statusCode = 401;
    }
}
exports.IdentityDriverBase = IdentityDriverBase;
function loadIdentitySource(config) {
    let driverPath = config.driver.match(/^[\w\d]+$/) ? __dirname + "/identity/" + config.driver : config.driver;
    return require.main.require(driverPath).createDriver(config.config);
}
exports.loadIdentitySource = loadIdentitySource;
//# sourceMappingURL=IdentitySource.js.map