import { OutputSpec } from './Command';
import { HandlerType } from "./DataSource";
export declare type Columns = OutputSpec[];
export declare type Row = any[];
export interface APISuccessResponse {
    data: any;
    meta: {
        handler: HandlerType;
        authorization?: string;
    };
}
export interface APIErrorResponse {
    errors: APIError[];
    meta?: {
        batchIndex?: number;
    };
}
export interface APIError {
    status: number;
    detail: string;
}
export interface DatabaseResult {
    columns: Columns;
    rows: Row[];
}
export declare class OperationNotifier<T> {
    promise: Promise<T>;
    resultHandler: (r: T) => void;
    errorHandler: (e: Error) => void;
    constructor();
    sendResult(r: T): void;
    sendError(err: Error, debugInfo?: string): void;
    cancel(): void;
    _clearHandlers(): void;
}
export declare class DatabaseResultNotifier extends OperationNotifier<DatabaseResult> {
    resultHandler: (r: DatabaseResult) => void;
    errorHandler: (e: Error) => void;
    constructor();
    _clearHandlers(): void;
}
