"use strict";
/*
 * Copyright 2019 Quadrant LLC. (http://quadrant.agency/)
 *
 * This file is part of Quadrant Transit.
 *
 * Quadrant Transit is distributed without license for evaluation purposes only.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const IdentitySource_1 = require("../../lib/IdentitySource");
const log = require("../../lib/Logger");
function createDriver(config) {
    return new Driver().init(config);
}
exports.createDriver = createDriver;
class Driver extends IdentitySource_1.IdentityDriverBase {
    init(config) {
        this.config = config;
        for (let user of this.config.users) {
            if (!Array.isArray(user.roles)) {
                throw new Error(`roles is not an Array: ${user.roles}`);
            }
        }
        return this;
    }
    validateCredentials(credentials) {
        try {
            let credsObj = JSON.parse(Buffer.from(credentials, "base64").toString());
            for (let user of this.config.users) {
                if (credsObj.username == user.username) {
                    if (credsObj.password == user.password) {
                        return {
                            username: user.username,
                            roles: user.roles
                        };
                    }
                    else {
                        return null;
                    }
                }
            }
            return null;
        }
        catch (e) {
            log.warn(`Auth error: ${e.stack || e}`);
            return null;
        }
    }
}
//# sourceMappingURL=Simple.js.map