/*
 * Copyright 2019 Quadrant LLC. (http://quadrant.agency/)
 *
 * This file is part of Quadrant Transit.
 *
 * Quadrant Transit is distributed without license for evaluation purposes only. 
 */

import * as ds from "../../lib/DataSource";

export function createDriver(config) : ds.DeclaredDriver {
    var nsapi;
    return {
        handlerType: ds.HandlerType.Declared,
        useNamespaceAPI: function(_api:any) {
            nsapi = _api;
        },
        API: { 
            "echoNum(n : int) : int": function(n) {
                return Promise.resolve(n);
            },
            "callEcho(msg : string) : string": function(msg) {
                return nsapi.echo.call(msg);
            },
            "nothing() : null": function() {
                return Promise.resolve();
            }
        }
    };
}
