"use strict";
/*
 * Copyright 2019 Quadrant LLC. (http://quadrant.agency/)
 *
 * This file is part of Quadrant Transit.
 *
 * Quadrant Transit is distributed without license for evaluation purposes only.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const ds = require("../../lib/DataSource");
function createDriver(config) {
    var nsapi;
    return {
        handlerType: ds.HandlerType.Declared,
        useNamespaceAPI: function (_api) {
            nsapi = _api;
        },
        API: {
            "echo(msg : string) : string": function (msg) {
                return Promise.resolve(msg);
            },
            "echoNum(n : int) : int": function (n) {
                return Promise.resolve(n);
            },
            "callEcho(msg : string) : string": function (msg) {
                return nsapi.echo.call(msg);
            },
            "nothing() : null": function () {
                return Promise.resolve();
            }
        }
    };
}
exports.createDriver = createDriver;
//# sourceMappingURL=EchoDeclaredDriver.js.map