"use strict";
/*
 * Copyright 2019 Quadrant LLC. (http://quadrant.agency/)
 *
 * This file is part of Quadrant Transit.
 *
 * Quadrant Transit is distributed without license for evaluation purposes only.
 */
Object.defineProperty(exports, "__esModule", { value: true });
function createDriver(dbapi) {
    return {
        API: {
            "echoNum(n : int) : int": function (n) {
                return Promise.resolve(n);
            },
            "callEcho(msg : string) : string": function (msg) {
                return dbapi.echo.call(msg);
            },
            "nothing() : null": function () {
                return Promise.resolve();
            }
        }
    };
}
exports.createDriver = createDriver;
//# sourceMappingURL=ExtensionDriver.js.map